Imports System
Imports System.Data.SqlClient
Imports System.EnterpriseServices
Imports System.Windows.Forms

<ObjectPooling(True, 3, 10), _
JustInTimeActivation(True)> _
Public Class Pooled
    Inherits ServicedComponent

    Private Shared ObjectCounter As Integer = 0
    Private ObjectId As Integer

    Public Sub New()
        System.Threading.Interlocked.Increment(ObjectCounter)
        ObjectId = ObjectCounter

        'lengthy constructor code
        MessageBox.Show("Pooled Constructor", ObjectId.ToString())
    End Sub

    Public Sub Test()
        MessageBox.Show("Method Running", ObjectId.ToString())
        ContextUtil.DeactivateOnReturn = True
    End Sub

    Protected Overrides Sub Activate()

        MessageBox.Show("Activate", ObjectId.ToString())
        MyBase.Activate()
    End Sub

    Protected Overrides Sub Deactivate()

        MessageBox.Show("DeActivate", ObjectId.ToString())
        MyBase.Deactivate()
    End Sub
    Protected Overrides Function CanBePooled() As Boolean

        MessageBox.Show("CanBePooled", ObjectId.ToString())
        Return True
    End Function


    Protected Overrides Sub Finalize()
        System.Threading.Interlocked.Decrement(ObjectCounter)
        MyBase.Finalize()
    End Sub
End Class